package com.fuyuanshen.web.controller.device.bjq;

import com.fuyuanshen.app.domain.bo.AppPersonnelInfoBo;
import com.fuyuanshen.app.domain.dto.AppDeviceLogoUploadDto;
import com.fuyuanshen.app.domain.dto.DeviceInstructDto;
import com.fuyuanshen.app.domain.vo.AppDeviceDetailVo;
import com.fuyuanshen.common.core.domain.R;
import com.fuyuanshen.common.core.validate.AddGroup;
import com.fuyuanshen.common.ratelimiter.annotation.FunctionAccessAnnotation;
import com.fuyuanshen.common.ratelimiter.annotation.FunctionAccessBatcAnnotation;
import com.fuyuanshen.common.web.core.BaseController;
import com.fuyuanshen.equipment.domain.dto.AppDeviceSendMsgBo;
import com.fuyuanshen.web.service.device.DeviceBJQBizService;
import jakarta.validation.constraints.NotNull;
import lombok.RequiredArgsConstructor;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

/**
 * web后台:设备控制类
 * 6075
 */
@Validated
@RequiredArgsConstructor
@RestController
@RequestMapping("/api/bjq6075/device")
public class DeviceBJQ6075Controller extends BaseController {

    private final DeviceBJQBizService appDeviceService;


    /**
     * 获取设备详细信息
     *
     * @param id 主键
     */
    @GetMapping("/{id}")
    public R<AppDeviceDetailVo> getInfo(@NotNull(message = "主键不能为空")
                                        @PathVariable Long id) {
        return R.ok(appDeviceService.getInfo(id));
    }


    /**
     * 人员信息登记
     */
    @PostMapping(value = "/registerPersonInfo")
//    @FunctionAccessAnnotation("registerPersonInfo")
    public R<Void> registerPersonInfo(@Validated(AddGroup.class) @RequestBody AppPersonnelInfoBo bo) {
        return toAjax(appDeviceService.registerPersonInfo(bo));
    }


    /**
     * 发送信息
     */
    @PostMapping(value = "/sendMessage")
    @FunctionAccessBatcAnnotation(value = "sendMessage", timeOut = 30, batchMaxTimeOut = 40)
    public R<Void> sendMessage(@RequestBody AppDeviceSendMsgBo bo) {
        return toAjax(appDeviceService.sendMessage(bo));
    }


    /**
     * 发送报警信息
     */
    @PostMapping(value = "/sendAlarmMessage")
    @FunctionAccessBatcAnnotation(value = "sendAlarmMessage", timeOut = 5, batchMaxTimeOut = 10)
    public R<Void> sendAlarmMessage(@RequestBody AppDeviceSendMsgBo bo) {
        return toAjax(appDeviceService.sendAlarmMessage(bo));
    }


    /**
     * 上传设备logo图片
     */
    @PostMapping("/uploadLogo")
    @FunctionAccessAnnotation("uploadLogo")
    public R<Void> upload(@Validated @ModelAttribute AppDeviceLogoUploadDto bo) {

        MultipartFile file = bo.getFile();
        if (file.getSize() > 1024 * 1024 * 2) {
            return R.warn("图片不能大于2M");
        }
        appDeviceService.uploadDeviceLogo(bo);

        return R.ok();
    }


    /**
     * 批量上传设备logo图片
     */
    @PostMapping("/batchUploadLogo")
    @FunctionAccessAnnotation("batchUploadLogo")
    public R<Void> batchUploadLogo(@Validated @ModelAttribute AppDeviceLogoUploadDto bo) {

        MultipartFile file = bo.getFile();
        if (file.getSize() > 1024 * 1024 * 2) {
            return R.warn("图片不能大于2M");
        }
        appDeviceService.batchUploadLogo(bo);

        return R.ok();
    }

    /**
     * 灯光模式
     * 0（关灯），1（强光模式），2（弱光模式）,  3（爆闪模式）,   4（泛光模式）
     */
//    @FunctionAccessAnnotation("lightModeSettings")
    @PostMapping("/lightModeSettings")
    public R<Void> lightModeSettings(@RequestBody DeviceInstructDto params) {
        // params 转 JSONObject
        appDeviceService.lightModeSettings(params);
        return R.ok();
    }

    /**
     * 灯光亮度设置
     */
//    @FunctionAccessAnnotation("lightBrightnessSettings")
    @PostMapping("/lightBrightnessSettings")
    public R<Void> lightBrightnessSettings(@RequestBody DeviceInstructDto params) {
        appDeviceService.lightBrightnessSettings(params);
        return R.ok();
    }

    /**
     * 激光模式设置
     */
    @PostMapping("/laserModeSettings")
//    @FunctionAccessAnnotation("laserModeSettings")
    public R<Void> laserModeSettings(@RequestBody DeviceInstructDto params) {
        appDeviceService.laserModeSettings(params);
        return R.ok();
    }

}
